<template>
    <div class="box">
        <article class="media">
            <div class="media-content">
                <h4 class="title is-4 content">
                    {{ kara.filename }}{{ showSource ? ' - '+kara.source:'' }}
                </h4>
            </div>
            <div class="media-right">
                <button class="button is-danger" v-if="admin !== ''" :disabled="done.delete" :class="{'is-loading': loading}" @click="subDelete">{{ $t('kara.remove') }}</button>
                <button class="button is-success" :disabled="done.vote" :class="{'is-loading': loading}" @click="submit('like')">{{ done.vote ? $t('kara.ok'):$t('kara.yes') }} ({{ kara.likes }})</button>
            </div>
        </article>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue'
    import { likesStore, adminStore } from "~/store";

    export default Vue.extend({
        props: {
            kara: Object,
            showSource: Boolean
        },

        data() {
            return {
                loading: false,
                done: {
                    delete: false,
                    vote: false
                },
                admin: adminStore.auth
            }
        },

        created() {
            if (likesStore.karas.find(el => el === this.kara.id) !== undefined) this.done.vote = true;
        },

        methods: {
            async submit(type: string) {
                this.loading = true;
                await this.$axios.post(`${process.env.APP_URL}/api/karas/${this.kara.id}`, {
                    type
                });
                likesStore.addKara(this.kara.id);
                this.loading = false;
                this.done.vote = true;
                this.kara.likes++;
            },
            async subDelete() {
                this.loading = true;
                await this.$axios.delete(`${process.env.APP_URL}/api/karas/${this.kara.id}`, {
                    data: {
                        api_token: this.admin
                    }
                });
                this.loading = false;
                this.done.delete = true;
            }
        }
    });
</script>

<style lang="scss">
div.media-content {
    margin: auto 0;
}

h4.title {
    overflow: hidden;
}

@media (max-width: 540px) {
    div.media-right {
        flex-shrink: unset;
    }
    div.button {
        justify-content: right;
    }
}
</style>
